'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _zenscroll = require('zenscroll');

var _zenscroll2 = _interopRequireDefault(_zenscroll);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Onboard = function (_Component) {
  _inherits(Onboard, _Component);

  function Onboard() {
    _classCallCheck(this, Onboard);

    var _this = _possibleConstructorReturn(this, (Onboard.__proto__ || Object.getPrototypeOf(Onboard)).call(this));

    _this.unsubscribe = _this.unsubscribe.bind(_this);
    _this.updateStep = _this.updateStep.bind(_this);
    _this.highlightChild = _this.highlightChild.bind(_this);
    _this.state = { running: false };
    return _this;
  }

  _createClass(Onboard, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.context.onbSubscribe(this);
      window.addEventListener((0, _helpers.eventId)(this.props.step), this.highlightChild);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe() {
      // Don't want any more event listeners for this component
      window.removeEventListener((0, _helpers.eventId)(this.props.step), this.highlightChild);
    }
  }, {
    key: 'updateStep',
    value: function updateStep() {
      var _this2 = this;

      var style = this.props.style;

      this.context.onbUpdateStep();
      this._node.style = null;
      if (style) {
        // If styles exist, keep track of user defined style
        Object.keys(style).map(function (styleKey) {
          return _this2._node.style['' + styleKey] = style[styleKey];
        });
      }
      this._node.removeAttribute("onclick"); // Don't want that onclick to do anything
      this.unsubscribe();
      this.setState({ running: false });
    }
  }, {
    key: 'highlightChild',
    value: function highlightChild() {
      var _this3 = this;

      var _props = this.props,
          scroll = _props.scroll,
          time = _props.time;

      this.setState({ running: true });
      if (scroll) _zenscroll2.default.intoView(this._node); // Only scroll to item if scroll prop is added

      // If a time exists, set the timeout to get rid of it.
      var timeExists = Number.isInteger(time);
      var updateStepTimeout = null;
      if (timeExists) {
        updateStepTimeout = setTimeout(function () {
          _this3.updateStep(_this3._node);
        }, time);
      }

      // Set some onclicks to clear the timeout and update the step
      document.getElementById("onboarder-overlay").onclick = function () {
        clearTimeout(updateStepTimeout);
        _this3.updateStep();
      };

      this._node.onclick = function () {
        clearTimeout(updateStepTimeout);
        _this3.updateStep();
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props2 = this.props,
          children = _props2.children,
          style = _props2.style,
          className = _props2.className,
          rest = _objectWithoutProperties(_props2, ['children', 'style', 'className']);

      if (this.state.running === false) {
        return _react2.default.cloneElement(children, { ref: function ref(i) {
            _this4._node = i;
          } });
      }

      var newProps = {
        className: ((children.props.className || '') + ' ' + (className || '')).trim(),
        style: _extends({}, children.props.style, style, { zIndex: "99999", position: "relative" }),
        ref: function ref(i) {
          return _this4._node = i;
        }
      };
      if (newProps.className.length === 0) delete newProps.className;

      var childrenWithProps = _react2.default.cloneElement(children, newProps);

      return childrenWithProps;
    }
  }]);

  return Onboard;
}(_react.Component);

Onboard.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]),
  className: _propTypes2.default.string,
  scroll: _propTypes2.default.bool,
  step: _propTypes2.default.number,
  style: _propTypes2.default.object,
  time: _propTypes2.default.number
};
Onboard.defaultProps = {
  scroll: false,
  step: 0,
  time: undefined
};
Onboard.contextTypes = {
  onbSubscribe: _propTypes2.default.func,
  onbUpdateStep: _propTypes2.default.func
};
exports.default = Onboard;