'use strict';

exports.__esModule = true;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _hexRgb = require('hex-rgb');

var _hexRgb2 = _interopRequireDefault(_hexRgb);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Onboarder = function (_Component) {
  _inherits(Onboarder, _Component);

  function Onboarder() {
    _classCallCheck(this, Onboarder);

    var _this = _possibleConstructorReturn(this, (Onboarder.__proto__ || Object.getPrototypeOf(Onboarder)).call(this));

    _this.onbUpdateStep = _this.onbUpdateStep.bind(_this);
    _this.onbSubscribe = _this.onbSubscribe.bind(_this);
    _this.stopOnboarder = _this.stopOnboarder.bind(_this);

    _this.subscribers = [];
    _this.state = { step: 0, max: 0, stopped: true };
    return _this;
  }

  _createClass(Onboarder, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        onbSubscribe: this.onbSubscribe,
        onbUpdateStep: this.onbUpdateStep
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var _props = this.props,
          alpha = _props.alpha,
          color = _props.color,
          delay = _props.delay;

      var rgbColor = (0, _hexRgb2.default)(color);
      var el = document.createElement("div");
      el.id = "onboarder-overlay";
      el.style.cssText = '\n      background: rgba(' + rgbColor[0] + ', ' + rgbColor[1] + ', ' + rgbColor[2] + ', ' + alpha + ');\n      width: 100%;\n      height: 100%;\n      position: fixed;\n      top: 0;\n      left: 0;\n      right: 0;\n      bottom: 0;\n      z-index: 99998;\n      display: none;\n    ';
      document.body.appendChild(el);
      setTimeout(function () {
        _this2.setState({ stopped: false });
      }, this.props.delay);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var node = document.getElementById('onboarder-overlay');
      if (this.props.show && this.state.stopped === false) {
        if (this.state.step >= this.state.max) {
          node.removeAttribute("onclick");
          this.stopOnboarder();
          this.removeOverlay();
        } else if (this.state.step !== this.state.max) {
          node.style.display = "block";
          this.notifySubscribers(this.subscribers[this.state.step]);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeOverlay();
    }
  }, {
    key: 'onbUpdateStep',
    value: function onbUpdateStep() {
      this.setState({ step: this.state.step + 1 });
    }
  }, {
    key: 'onbSubscribe',
    value: function onbSubscribe(handler) {
      this.subscribers = this.subscribers.concat(handler);
      this.setState({ max: this.subscribers.length });
    }
  }, {
    key: 'removeOverlay',
    value: function removeOverlay() {
      var overlay = document.getElementById("onboarder-overlay");
      if (overlay) overlay.remove();
    }
  }, {
    key: 'stopOnboarder',
    value: function stopOnboarder() {
      this.setState({ stopped: true });
    }
  }, {
    key: 'notifySubscribers',
    value: function notifySubscribers(subscriber) {
      var evt = new Event((0, _helpers.eventId)(this.state.step));
      window.dispatchEvent(evt);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'div',
        { ref: function ref(i) {
            return _this3._node = i;
          } },
        this.props.children
      );
    }
  }]);

  return Onboarder;
}(_react.Component);

Onboarder.propTypes = {
  alpha: _propTypes2.default.string,
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]),
  color: _propTypes2.default.string,
  delay: _propTypes2.default.number,
  show: _propTypes2.default.bool
};
Onboarder.defaultProps = {
  alpha: "0.3",
  color: "000000",
  delay: 0,
  show: true
};
Onboarder.childContextTypes = {
  onbSubscribe: _propTypes2.default.func,
  onbUpdateStep: _propTypes2.default.func
};
exports.default = Onboarder;